indexing
	description: "An eye linerar TexCoord Generator (TCG)"
	documentation: "Documentation of class"
	date: "$Date: Jul 11, 2006 8:49:22 PM$"
	revision: "$Revision: 1.0$"

class EM3D_EYE_TCG

inherit
	EM3D_TCG
		redefine
			enable_generation,
			reset_coords
		end
	EMGL_TEXGEN
		export {NONE} all end
	EMGL_VIEW
		export {NONE} all end
	EM_CONSTANTS
		export {NONE} all end

feature
	enable_generation is
			-- Enable the tex_coord generation
		do
			Precursor
			emgl_tex_geni( em_gl_s, em_gl_texture_gen_mode, em_gl_eye_linear )
			emgl_tex_geni( em_gl_t, em_gl_texture_gen_mode, em_gl_eye_linear )
			emgl_tex_geni( em_gl_r, em_gl_texture_gen_mode, em_gl_eye_linear )
			emgl_tex_geni( em_gl_q, em_gl_texture_gen_mode, em_gl_eye_linear )
		end

feature {EM3D_EYE_TCG}
	projection_matrix: EM_MATRIX44
	modelview_matrix: EM_MATRIX44

	init_matrices is
			-- Initialize the projection- and modelview-matrix
		do
			emgl_get_doublev( em_gl_projection_matrix, projection_matrix )
			emgl_get_doublev( em_gl_modelview_matrix, modelview_matrix )
		end

	init_coords is
			-- Initialize the tex_coord generation
		local
			vec4: EM_VECTOR4D
		do
			vec4:=[1.0,0.0,0.0,0.0]
			emgl_tex_gendv( em_gl_s, em_gl_eye_plane, $vec4)
			vec4:=[0.0,1.0,0.0,0.0]
			emgl_tex_gendv( em_gl_t, em_gl_eye_plane, $vec4)
			vec4:=[0.0,0.0,1.0,0.0]
			emgl_tex_gendv( em_gl_r, em_gl_eye_plane, $vec4)
			vec4:=[0.0,0.0,0.0,1.0]
			emgl_tex_gendv( em_gl_q, em_gl_eye_plane, $vec4)

			emgl_matrix_mode( em_gl_texture )

			init_matrices
			emgl_push_matrix
			emgl_load_identity
 			emgl_translatef(0.5, 0.5, 0.5)
 			emgl_scalef(0.5, 0.5, 0.5)
 			emgl_mult_matrixd( projection_matrix )
			emgl_mult_matrixd( modelview_matrix )

			emgl_matrix_mode( em_gl_modelview )
		end
	reset_coords is
			-- Reset the tex coords back to normal
		do
			emgl_matrix_mode( em_gl_texture )
			emgl_pop_matrix
			emgl_matrix_mode( em_gl_modelview )
		end

end -- class EM3D_EYE_TEX_COORD_GENERATOR
